--
-- Mod: Display Date for Seasons Mod
--
-- Author: D3r1L
-- email: 
-- @Date: 22.08.2019
-- @Version: 1.0.0.0 
-- Copyright (C) D3r1L, All Rights Reserved.

DisplayDate4Seasons = {};

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");

addModEventListener(DisplayDate4Seasons);

function DisplayDate4Seasons:loadMap(name)
end;

function DisplayDate4Seasons:update(dt)
end;

function DisplayDate4Seasons:draw()
    if g_dedicatedServerInfo ~= nil or not g_currentMission.renderTime or not g_currentMission.hud.showTime then
		return
	end
	
  local r, g, b, a = self:getColor("white");
  setTextColor(r, g, b, a);
  local fontSize = (g_gameSettings:getValue("uiScale") *  0.015);
  --print(string.format('CITY ECONMY fontSize:'..tostring(fontSize)));
  fontSize = fontSize * 0.9;
  --local date = getDate(self.timeFormat)
  local posX = 0.73; -- 0.9
  local posY = 0.98;
  local myDay = 0;
  local mese = "mese";
  local weekDay = "weekDay";
  local myPeriod = g_seasons.weather.forecast.environment.period;
  local daysPerMouth = g_seasons.weather.forecast.environment.daysPerSeason / 3;
  --local anno = ""; --tonumber(date) + g_seasons.weather.forecast.environment.year;
	local dayInSeason = g_seasons.environment.dayInSeason;
	
	if daysPerMouth == 1 then
		myDay = 13 + dayInSeason;
	elseif daysPerMouth == 2 then
		myDay = 13 + dayInSeason;
	elseif daysPerMouth == 3 then
		myDay = 11 + dayInSeason;
	elseif daysPerMouth == 4 then
		myDay = 10 + dayInSeason;
	elseif daysPerMouth == 5 then
		myDay = 8 + dayInSeason;
	elseif daysPerMouth == 6 then
		myDay = 6 + dayInSeason;
	elseif daysPerMouth == 7 then
		myDay = 4 + dayInSeason;
	elseif daysPerMouth == 8 then
		myDay = 2 + dayInSeason;
	end;
	
	if myPeriod == 1 then
		mese = g_i18n:getText("showMonth1");
	elseif myPeriod == 2 then
		mese = g_i18n:getText("showMonth2");
	elseif myPeriod == 3 then
		mese = g_i18n:getText("showMonth3");
	elseif myPeriod == 4 then
		mese = g_i18n:getText("showMonth4");
	elseif myPeriod == 5 then
		mese = g_i18n:getText("showMonth5");
	elseif myPeriod == 6 then
		mese = g_i18n:getText("showMonth6");
	elseif myPeriod == 7 then
		mese = g_i18n:getText("showMonth7");
	elseif myPeriod == 8 then
		mese = g_i18n:getText("showMonth8");
	elseif myPeriod == 9 then
		mese = g_i18n:getText("showMonth9");
	elseif myPeriod == 10 then
		mese = g_i18n:getText("showMonth10");
	elseif myPeriod == 11 then
		mese = g_i18n:getText("showMonth11");
	elseif myPeriod == 12 then
		mese = g_i18n:getText("showMonth12");
	end;
	
	local diffWeekDay = math.floor(g_seasons.environment.currentDay / 7);
	local currWeekDay = g_seasons.environment.currentDay - (diffWeekDay * 7);
	
	if currWeekDay == 0 then
		currWeekDay = 7;
	end;
	
	--print("diffWeekDay: " .. tostring(diffWeekDay));
	--print("currWeekDay: " .. tostring(currWeekDay));
	
	if currWeekDay == 1 then
		weekDay = g_i18n:getText("showWeekDay1");
	elseif currWeekDay == 2 then
		weekDay = g_i18n:getText("showWeekDay2");
	elseif currWeekDay == 3 then
		weekDay = g_i18n:getText("showWeekDay3");
	elseif currWeekDay == 4 then
		weekDay = g_i18n:getText("showWeekDay4");
	elseif currWeekDay == 5 then
		weekDay = g_i18n:getText("showWeekDay5");
	elseif currWeekDay == 6 then
		weekDay = g_i18n:getText("showWeekDay6");
	elseif currWeekDay == 7 then
		weekDay = g_i18n:getText("showWeekDay7");
	end;
	
	local myDate = mese .. ", " .. weekDay .. " " .. tostring(myDay);
	local width = getTextWidth(fontSize, myDate);
    --local height = getTextHeight(fontSize, myDate)
    posX = 0.80 - width;
	
	--renderText(posX, posY, fontSize, "Gennaio, ");-- .. tostring(date));
	renderText(posX, posY, fontSize, myDate);
	
	-- Drying Grass - Hay
    local today = g_seasons.environment.currentDay;
    local currentHour = g_seasons.weather.forecast.environment.mission.environment.currentHour;
	
    --- Lower to nearest block
    local currentTimeBlock = math.floor(currentHour / 3) * 3
	
	--print("today = " .. today);
	--print("currentHour = " .. currentHour);
	--print("currentTimeBlock = " .. currentTimeBlock);
	
    for i = 1, 16 do
        local day, time, duration = today, 0, 3

        -- Do slots first, then do days
        if i <= 10 then
            time = currentTimeBlock + (i - 1) * 3
            if time >= 24 then
                time = time - 24
                day = day + 1
            end
        else
            day = day + (i - 10)
            duration = 24
        end;
		
		--print("day = " .. tostring(day) .. " - time = " .. tostring(time) .. " - duration = " .. tostring(duration));
		
		local forecastInfo = g_seasons.weather:getForecast(day, time, duration);
		
		local dryingGrass = "";
		if forecastInfo.dryingPotential <= -9 then
			dryingGrass = "(++)"
		elseif forecastInfo.dryingPotential <= -2 then
			dryingGrass = "(+)"
		elseif forecastInfo.dryingPotential <= 0.2 then
			dryingGrass = "(0)"
		elseif forecastInfo.dryingPotential <= 2 then
			dryingGrass = "(-)"
		else
			dryingGrass = "(--)"
		end
		
		--print("dryingGrass = " .. tostring(dryingGrass));
		posY = 0.975;
		fontSize = (g_gameSettings:getValue("uiScale") *  0.015);
		--fontSize = fontSize * 1.1;
		width = getTextWidth(fontSize, dryingGrass);
		setTextAlignment(RenderText.ALIGN_CENTER);
		setTextWrapWidth(0);
		--local height = getTextHeight(fontSize, myDate)
		posX = 0.60; -- - width;
		renderText(posX, posY, fontSize, dryingGrass);
		setTextWrapWidth(0)
		break;
    end;
	
end;

function DisplayDate4Seasons:getColor(source)
  local color = source:lower()
  if color == "white" then
    return 1, 1, 1, 1
  elseif color == "black" then
    return 0, 0, 0, 1
  else
    local splitted = Utils.splitString(",", color)
    local colors = {}
    for _, v in pairs(splitted) do
      table.insert(colors, tonumber(v))
    end
    return unpack(colors)
  end
end;